Subject: Re: [NET_SCHED 00/04]: External SFQ classifiers/flow classifier

From: Patrick McHardy <[email-masked]>
Date: Mon, 07 Apr 2008 15:44:35 +0200

Andy Furniss wrote:
> Andy Furniss wrote:
>> Andy Furniss wrote:
>>
>>> Looking at the sfq code it seems that enqueue doesn't init/zero allot 
>>> for a new flow unless it's the first and most of what I see fits with 
>>> this. 
>>
>>> But rarely it doesn't look like that's all there is to it.
>>
>> Actually it fits perfectly, so that is all there is to it. Dequeue 
>> dequeues first then checks allot so even if the allot is stuck at 
>> -20345 or something the flow will still get 1 packet per round which 
>> is what I've seen. I first thought it should have moved towards 0 like 
>> it does when it starts too high.
> 
> Seems like this change fixes it for me, though I since noticed that 
> requeue will need the same change as well.
> 
> --- sch_sfq.c.orig      2008-04-07 11:42:36.000000000 +0100
> +++ sch_sfq.c   2008-04-07 11:46:41.000000000 +0100
> @@ -317,6 +317,7 @@
>                         q->next[x] = q->next[q->tail];
>                         q->next[q->tail] = x;
>                         q->tail = x;
> +                       q->allot[x] = 0;

That might fix the symptom, but I don't think its correct.
As I said, you can't simply reset to zero since it might cause
unfairness of bursty flows against non-bursty flows.